using System;
using System.Text;

namespace Smdn.Protocols.Imap4 {
  // StringTypes:
  //   ImapString
  //     => handles 'string'
  //     ImapQuotedString
  //       => handles 'quoted'
  //     ImapLiteralString
  //       => handles 'literal'
  //     ImapStringList
  //       => list of ImapString
  //       ImapParenthesizedString
  //         => handles 'parenthesized list'

  public class ImapLiteralString : ImapString {
    public Encoding Charset {
      get { return charset; }
      internal set { charset = value; }
    }

    internal int Octets {
      get { return charset.GetByteCount(base.Value); }
    }

    public ImapLiteralString(string val)
      : this(val, ImapEncoding.Encoding8Bit)
    {
    }

    public ImapLiteralString(string val, Encoding charset)
      : base(val)
    {
      if (charset == null)
        throw new ArgumentNullException("charset");

      this.charset = charset;
    }

    public override string ToString()
    {
      return string.Format("{{{0}}}\r\n{1}",
                           Octets,
                           base.Value);
    }

    private Encoding charset;
  }
}