using System;

namespace Smdn.Protocols.Imap4 {
  public class ImapMailboxFlag {
    public ImapKnownMailboxFlags KnownMailboxFlags {
      get { return knownMailboxFlags; }
      internal set { knownMailboxFlags = value; }
    }

    public string[] AllMailboxFlags {
      get { return allMailboxFlags; }
      internal set { allMailboxFlags = value; }
    }

    internal ImapMailboxFlag()
      : this(ImapKnownMailboxFlags.None)
    {
    }

    internal ImapMailboxFlag(ImapKnownMailboxFlags knownMailboxFlags)
      : this(knownMailboxFlags, new string[] {})
    {
    }

    internal ImapMailboxFlag(ImapKnownMailboxFlags knownMailboxFlags, string[] allMailboxFlags)
    {
      this.knownMailboxFlags = knownMailboxFlags;
      this.allMailboxFlags = allMailboxFlags;
    }

    public bool Has(ImapKnownMailboxFlags flag)
    {
      return (0 != (knownMailboxFlags & flag));
    }

    public bool Has(string flag)
    {
      foreach (var f in allMailboxFlags) {
        if (flag.Equals(f, StringComparison.InvariantCultureIgnoreCase))
          return true;
      }

      return false;
    }

    public override string ToString()
    {
      return string.Format("{{KnownMailboxFlags={0}, AllMailboxFlags={1}}}",
                           knownMailboxFlags,
                           string.Join(" ", allMailboxFlags));
    }

    private ImapKnownMailboxFlags knownMailboxFlags;
    private string[] allMailboxFlags;
  }
}
