using System;

namespace Smdn.Protocols.Imap4 {
  // StringTypes:
  //   ImapString
  //     => handles 'string'
  //     ImapQuotedString
  //       => handles 'quoted'
  //     ImapLiteralString
  //       => handles 'literal'
  //     ImapStringList
  //       => list of ImapString
  //       ImapParenthesizedString
  //         => handles 'parenthesized list'

  public class ImapString {
    protected internal string Value {
      get { return val; }
    }

    protected ImapString()
    {
      this.val = null;
    }

    public ImapString(string val)
    {
      if (val == null)
        throw new ArgumentNullException("val");

      this.val = val;
    }

    public static implicit operator ImapString(string str)
    {
      return new ImapString(str);
    }

    public static explicit operator string(ImapString str)
    {
      return str.ToString();
    }

    public override string ToString()
    {
      return val;
    }

    private readonly string val;
  }
}
