using System;

namespace Smdn.Protocols.Imap4.Transaction {
  // Layers:
  //   Client.ImapClient
  //   Client.ImapClientAgent
  //   Session.ImapSessionAgent
  //   Session.ImapSession
  //   Transaction.ImapTransactionAgent
  // * Transaction.ImapTransaction/Transaction.ImapRequest/Transaction.ImapResponse
  //   Protocol.ImapConnection/Protocol.ImapProtocolCommand/Protocol.ImapProtocolResponse
  //   (IMAP4)

  public class ImapResponse {
    public ImapTransactionStatus Status {
      get { return status; }
    }

    public string Description {
      get { return description; }
    }

    internal ImapResponse(ImapTransactionStatus status, string description)
    {
      this.status = status;
      this.description = description;
    }

    public override string ToString()
    {
      return string.Format("{{Status={0} Description={1}}}", status, description);
    }

    private readonly ImapTransactionStatus status;
    private readonly string description;
  }
}
