using System;

namespace Smdn.Protocols.Pop3 {
  public class PopMessage {
    public int Number {
      get { return number; }
    }

    public string Body {
      get { return body; }
      internal set { body = value; }
    }

    public string Uid {
      get { return uid; }
      internal set { uid = value; }
    }

    public int Octets {
      get { return octets; }
      internal set { octets = value; }
    }

    public PopMailbox Mailbox {
      get { return mailbox; }
      internal set { mailbox = value; }
    }

    internal PopMessage(PopScanList scanList)
      : this(scanList.MessageNumber, null)
    {
      this.octets = scanList.Octets;
    }

    internal PopMessage(int number, string body)
    {
      this.number = number;
      this.body = body;
    }

    public override string ToString()
    {
      return string.Format("{{Number={0}, Uid={1}, Octets={2}, Body={3}}}",
                           number,
                           uid,
                           octets,
                           body);
    }

    private readonly int number;
    private string body;
    private string uid = null;
    private int octets = 0;
    private PopMailbox mailbox = null;
  }
}
