using System;

using Smdn.Protocols.Pop3.Protocol;

namespace Smdn.Protocols.Pop3.Transaction.Transactions {
  internal class QuitTransaction : TransactionBase {

    // ProcessQuit
    //   ->WaitForQuit
    // WaitForQuit
    //   x Conclude

    public QuitTransaction(PopConnection connection, PopRequest request)
      : base(connection, request)
    {
    }

    protected override ProcessTransactionDelegate Reset()
    {
      return ProcessQuit;
    }

    private void ProcessQuit()
    {
      Send("QUIT");

      Transit(WaitForQuit);
    }

    private void WaitForQuit()
    {
      PopProtocolResponse response;

      if (!Receive(out response))
        return;

      if (response is PopStatusResponse) {
        var status = response as PopStatusResponse;

        if (status.Status == PopProtocolStatus.Positive) {
          Conclude(new PopResponse(PopTransactionStatus.Ok, "quitted"));
        }
        else {
          ConcludeError(status);
        }
      }
    }
  }
}
